"""Subpackage."""

from typing import TYPE_CHECKING as __tc

if __tc:
    from mastapy._private.bearings._1933 import BearingCatalog
    from mastapy._private.bearings._1934 import BasicDynamicLoadRatingCalculationMethod
    from mastapy._private.bearings._1935 import BasicStaticLoadRatingCalculationMethod
    from mastapy._private.bearings._1936 import BearingCageMaterial
    from mastapy._private.bearings._1937 import BearingDampingMatrixOption
    from mastapy._private.bearings._1938 import BearingLoadCaseResultsForPST
    from mastapy._private.bearings._1939 import BearingLoadCaseResultsLightweight
    from mastapy._private.bearings._1940 import BearingMeasurementType
    from mastapy._private.bearings._1941 import BearingModel
    from mastapy._private.bearings._1942 import BearingRow
    from mastapy._private.bearings._1943 import BearingSettings
    from mastapy._private.bearings._1944 import BearingSettingsDatabase
    from mastapy._private.bearings._1945 import BearingSettingsItem
    from mastapy._private.bearings._1946 import BearingStiffnessMatrixOption
    from mastapy._private.bearings._1947 import (
        ExponentAndReductionFactorsInISO16281Calculation,
    )
    from mastapy._private.bearings._1948 import FluidFilmTemperatureOptions
    from mastapy._private.bearings._1949 import HybridSteelAll
    from mastapy._private.bearings._1950 import JournalBearingType
    from mastapy._private.bearings._1951 import JournalOilFeedType
    from mastapy._private.bearings._1952 import MountingPointSurfaceFinishes
    from mastapy._private.bearings._1953 import OuterRingMounting
    from mastapy._private.bearings._1954 import RatingLife
    from mastapy._private.bearings._1955 import RollerBearingProfileTypes
    from mastapy._private.bearings._1956 import RollingBearingArrangement
    from mastapy._private.bearings._1957 import RollingBearingDatabase
    from mastapy._private.bearings._1958 import RollingBearingKey
    from mastapy._private.bearings._1959 import RollingBearingRaceType
    from mastapy._private.bearings._1960 import RollingBearingType
    from mastapy._private.bearings._1961 import RotationalDirections
    from mastapy._private.bearings._1962 import SealLocation
    from mastapy._private.bearings._1963 import SKFSettings
    from mastapy._private.bearings._1964 import TiltingPadTypes
else:
    import sys as __sys

    from lazy_imports import LazyImporter as __LazyImporter

    __import_structure = {
        "_private.bearings._1933": ["BearingCatalog"],
        "_private.bearings._1934": ["BasicDynamicLoadRatingCalculationMethod"],
        "_private.bearings._1935": ["BasicStaticLoadRatingCalculationMethod"],
        "_private.bearings._1936": ["BearingCageMaterial"],
        "_private.bearings._1937": ["BearingDampingMatrixOption"],
        "_private.bearings._1938": ["BearingLoadCaseResultsForPST"],
        "_private.bearings._1939": ["BearingLoadCaseResultsLightweight"],
        "_private.bearings._1940": ["BearingMeasurementType"],
        "_private.bearings._1941": ["BearingModel"],
        "_private.bearings._1942": ["BearingRow"],
        "_private.bearings._1943": ["BearingSettings"],
        "_private.bearings._1944": ["BearingSettingsDatabase"],
        "_private.bearings._1945": ["BearingSettingsItem"],
        "_private.bearings._1946": ["BearingStiffnessMatrixOption"],
        "_private.bearings._1947": ["ExponentAndReductionFactorsInISO16281Calculation"],
        "_private.bearings._1948": ["FluidFilmTemperatureOptions"],
        "_private.bearings._1949": ["HybridSteelAll"],
        "_private.bearings._1950": ["JournalBearingType"],
        "_private.bearings._1951": ["JournalOilFeedType"],
        "_private.bearings._1952": ["MountingPointSurfaceFinishes"],
        "_private.bearings._1953": ["OuterRingMounting"],
        "_private.bearings._1954": ["RatingLife"],
        "_private.bearings._1955": ["RollerBearingProfileTypes"],
        "_private.bearings._1956": ["RollingBearingArrangement"],
        "_private.bearings._1957": ["RollingBearingDatabase"],
        "_private.bearings._1958": ["RollingBearingKey"],
        "_private.bearings._1959": ["RollingBearingRaceType"],
        "_private.bearings._1960": ["RollingBearingType"],
        "_private.bearings._1961": ["RotationalDirections"],
        "_private.bearings._1962": ["SealLocation"],
        "_private.bearings._1963": ["SKFSettings"],
        "_private.bearings._1964": ["TiltingPadTypes"],
    }

    __sys.modules[__name__] = __LazyImporter(
        "mastapy",
        globals()["__file__"],
        __import_structure,
    )

__all__ = (
    "BearingCatalog",
    "BasicDynamicLoadRatingCalculationMethod",
    "BasicStaticLoadRatingCalculationMethod",
    "BearingCageMaterial",
    "BearingDampingMatrixOption",
    "BearingLoadCaseResultsForPST",
    "BearingLoadCaseResultsLightweight",
    "BearingMeasurementType",
    "BearingModel",
    "BearingRow",
    "BearingSettings",
    "BearingSettingsDatabase",
    "BearingSettingsItem",
    "BearingStiffnessMatrixOption",
    "ExponentAndReductionFactorsInISO16281Calculation",
    "FluidFilmTemperatureOptions",
    "HybridSteelAll",
    "JournalBearingType",
    "JournalOilFeedType",
    "MountingPointSurfaceFinishes",
    "OuterRingMounting",
    "RatingLife",
    "RollerBearingProfileTypes",
    "RollingBearingArrangement",
    "RollingBearingDatabase",
    "RollingBearingKey",
    "RollingBearingRaceType",
    "RollingBearingType",
    "RotationalDirections",
    "SealLocation",
    "SKFSettings",
    "TiltingPadTypes",
)
